mod imp;

use adw::prelude::*;
use adw::subclass::prelude::*;
use glib::Object;
use gtk::glib;

glib::wrapper! {
    pub struct AppObject(ObjectSubclass<imp::AppObject>);
}

impl AppObject {
    pub fn new(name: &str, path: &str) -> Self {
        Object::builder()
            .property("name", name)
            .property("path", path)
            .build()
    }

    pub fn to_app_data(&self) -> AppData {
        let name = self.imp().name.borrow().clone();
        let path = self.imp().path.borrow().clone();

        AppData { name, path }
    }

    pub fn from_app_data(app_data: &AppData) -> Self {
        Self::new(&app_data.name, &app_data.path)
    }
}

#[derive(Default, Clone)]
pub struct AppData {
    pub name: String,
    pub path: String
}